var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { safe } from '../Annotation';
import { ImageUtils, LayoutUtils } from '../Utils';
import { Image } from './Image';
let FlexImage = class FlexImage extends React.Component {
    constructor(props) {
        super(props);
        this.calcImageSize = (width, height, contract, align) => {
            if (contract && contract.width > 0 && contract.height > 0) {
                if (width === Number.POSITIVE_INFINITY) {
                    width = contract.width;
                }
                if (height === Number.POSITIVE_INFINITY) {
                    height = contract.height;
                }
                if (width > 0 && height > 0) {
                    let dimension = contract;
                    switch (align) {
                        case 'center':
                        case 'repeat':
                        case 'cover':
                            dimension = LayoutUtils.calcCoverSize(width, height, contract);
                            break;
                        case 'fit':
                            dimension = LayoutUtils.calcFitSize(width, height, contract);
                            break;
                        case 'fill-horizontal':
                            dimension = LayoutUtils.calcFitHorizontalSize(width, height, contract);
                            break;
                        case 'fill-vertical':
                            dimension = LayoutUtils.calcFitVerticalSize(width, height, contract);
                            break;
                        default:
                            break;
                    }
                    this.setState({
                        width: dimension.width,
                        height: dimension.height,
                        loaded: true
                    });
                }
            }
        };
        this.state = {
            width: 0,
            height: 0,
            loaded: false
        };
    }
    componentDidMount() {
        this.alignImage();
    }
    componentDidUpdate(prevProps) {
        const { contract } = this.props;
        if (prevProps.contract && contract) {
            if (contract.width !== prevProps.contract.width || contract.height !== prevProps.contract.height) {
                this.alignImage();
            }
        }
    }
    render() {
        if (this.state.loaded) {
            const _a = this.props, { align, contract, style } = _a, imageProps = __rest(_a, ["align", "contract", "style"]);
            return (React.createElement(Image, Object.assign({}, imageProps, { width: this.state.width, height: this.state.height, style: [
                    {
                        maxWidth: '100%',
                        maxHeight: '100%',
                        resizeMode: LayoutUtils.calcResizeMode(align)
                    },
                    style
                ] })));
        }
        else {
            return null;
        }
    }
    alignImage() {
        const { source, contract, align, onError } = this.props;
        let uri = source.uri;
        if (uri) {
            ImageUtils.getSize(uri, (width, height) => {
                this.calcImageSize(width, height, contract, align);
            }, (error) => {
                if (onError) {
                    onError(error);
                }
            });
        }
    }
};
FlexImage = __decorate([
    safe
], FlexImage);
export { FlexImage };
