var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { DeviceEventEmitter, Platform, TouchableNativeFeedback, TouchableOpacity, View } from 'react-native';
import { Guid } from '../Shared';
export class Touchable extends React.Component {
    constructor(props) {
        super(props);
        this.testId = this.props.testID + Guid.newGuid();
    }
    componentDidMount() {
        if (Platform.OS === 'android') {
            DeviceEventEmitter.addListener('KeyEnter' + this.testId, this.props.onPress);
        }
    }
    componentWillUnmount() {
        if (Platform.OS === 'android') {
            DeviceEventEmitter.removeListener('KeyEnter' + this.testId, this.props.onPress);
        }
    }
    render() {
        const _a = this.props, { style, children } = _a, otherProps = __rest(_a, ["style", "children"]);
        if (Platform.OS === 'android') {
            return (React.createElement(TouchableNativeFeedback, Object.assign({}, otherProps, { accessible: true, testID: this.testId, useForeground: true, background: TouchableNativeFeedback.SelectableBackground() }),
                React.createElement(View, { style: style }, children)));
        }
        else {
            return (React.createElement(TouchableOpacity, Object.assign({}, otherProps, { accessible: true, testID: this.testId, style: style }), children));
        }
    }
}
