import { ImageSourcePropType } from 'react-native';
export declare enum ImageType {
    Remote = 0,
    Local = 1,
    Base64 = 2,
    Svg = 3,
    Unknown = 4
}
export declare class ImageUtils {
    static getSize(uri: string, success: (width: number, height: number) => void, failure: (error: any) => void): void;
    static prefetch(url: string): any;
    static abortPrefetch?(requestId: number): void;
    static queryCache?(urls: string[]): Promise<Map<string, "memory" | "disk">>;
    static resolveAssetSource(source: ImageSourcePropType): import("react-native").ImageResolvedAssetSource;
    static detectType(url: string): ImageType;
}
