export class LayoutUtils {
    static calcCoverSize(width, height, contract) {
        if (contract && contract.width > 0 && contract.height > 0) {
            if (width === Number.POSITIVE_INFINITY) {
                width = contract.width;
            }
            if (height === Number.POSITIVE_INFINITY) {
                height = contract.height;
            }
            if (width > 0 && height > 0) {
                let ratio = width / height;
                let contractRatio = contract.width / contract.height;
                if (ratio > contractRatio) {
                    return this.calcFitVerticalSize(width, height, contract);
                }
                else {
                    return this.calcFitHorizontalSize(width, height, contract);
                }
            }
        }
        return { width: width, height: height };
    }
    static calcFitSize(width, height, contract) {
        if (contract && contract.width > 0 && contract.height > 0) {
            if (width === Number.POSITIVE_INFINITY) {
                width = contract.width;
            }
            if (height === Number.POSITIVE_INFINITY) {
                height = contract.height;
            }
            if (width > 0 && height > 0) {
                let ratio = width / height;
                let contractRatio = contract.width / contract.height;
                if (ratio > contractRatio) {
                    return this.calcFitHorizontalSize(width, height, contract);
                }
                else {
                    return this.calcFitVerticalSize(width, height, contract);
                }
            }
        }
        return { width: width, height: height };
    }
    static calcFitVerticalSize(width, height, contract) {
        if (contract && contract.width > 0 && contract.height > 0) {
            if (width === Number.POSITIVE_INFINITY) {
                width = contract.width;
            }
            if (height === Number.POSITIVE_INFINITY) {
                height = contract.height;
            }
            if (width > 0 && height > 0) {
                let ratio = width / height;
                height = contract.height;
                width = ratio * height;
            }
        }
        return { width: width, height: height };
    }
    static calcFitHorizontalSize(width, height, contract) {
        if (contract && contract.width > 0 && contract.height > 0) {
            if (width === Number.POSITIVE_INFINITY) {
                width = contract.width;
            }
            if (height === Number.POSITIVE_INFINITY) {
                height = contract.height;
            }
            if (width > 0 && height > 0) {
                let ratio = width / height;
                width = contract.width;
                height = width / ratio;
            }
        }
        return { width: width, height: height };
    }
    static calcResizeMode(align) {
        if (align === 'center' || align === 'cover' || align === 'repeat') {
            return align;
        }
        if (align === 'fill-stretch') {
            return 'stretch';
        }
        if (align === 'fill-natural') {
            return 'cover';
        }
        return 'contain';
    }
}
